// loxodrome.js
// helmut jaksch	
// for scripts/Splineobj Folder

// definitions for property block GUI
function buildUI(obj) {
    
    obj.setParameter("name","js test");
    
    obj.addParameterSeparator("Variables");
	// "variable", default, lower / upper limit, ???, ???
    obj.addParameterFloat("radius",1,0,100,true,true);
    obj.addParameterInt("loops",3,1,100,true,true);
	obj.addParameterInt("v max",180,180,180,true,true);
    obj.addParameterInt("v inc",1,1,30,true,true);
	obj.addParameterInt("u max",360,1,3600,true,true);
    obj.addParameterInt("u inc",1,1,30,true,true);
}

function buildObject(obj) {
	// definitions local variables
    // obj.core = holds ∑ data of spline object
    var spline = obj.core();
    var x,y,z,u_crr;
    
    // assign user set parameters
    var r = obj.getParameter("radius");
    var loops = obj.getParameter("loops");
    var v_max = obj.getParameter("v max");
    var v_inc = obj.getParameter("v inc");
    var u_max = obj.getParameter("u max");
    var u_inc = obj.getParameter("u inc");

    // N-pole to S-pole loops
    for(var v=0;v<=180;v=v+v_inc) {
			// convert to radians
			v_crr=v;
			var v_rad=(v_crr/360)*Math.PI*2;
			
			// horizontal plane grogress
			// for(var u=v*2;u<=v+10;u=u+u_inc) {
				// calculate u angle
				u_crr=v*loops;
				var u_rad=(u_crr/360)*Math.PI*2;
			
				// generate circle points
				print("u,v = "+u_crr+", "+v_crr)
			
				var r_crr=r*Math.sin(v_rad)
				x=r_crr*Math.cos(u_rad)
				y=r*Math.cos(v_rad)
				z=r_crr*Math.sin(u_rad)

				// generate wave
				if(v==0)    
					spline.move(new Vec3D(x,y,z)); // move pen to start
				else	    
					spline.line(new Vec3D(x,y,z)); // draw segment
			// }
    }
		
		// spline.close();
    
}

